\def\Booster{\textsc{\mbox{Booster}}}
\def\Object{\textsc{\mbox{Object}}}
\def\Table{\textsc{\mbox{Table}}}
\def\Sql{\textsc{\mbox{Sql}}}
\def\PASS{\mathrel{\mathop:}=}
\def\PAND{\parallel}
\def\POR{\extchoice}
\def\PTHEN{\mathrel{;}}
\def\PGUARD{\longrightarrow}
\def\PEXISTS{\mbox{@}}
\def\PFORALL{\mbox{!}}

\def\Pass{\@ifnextchar~{\applyPass}{\_ \PASS \_}}
\def\applyPass~(#1, #2){#1 \PASS #2} 
\def\Pskip{skip}
\def\Pand{\@ifnextchar~{\applyPand}{\_ \PAND \_}}
\def\applyPand~(#1, #2){#1 \PAND #2}
\def\Por{\@ifnextchar~{\applyPor}{\_ \POR \_}}
\def\applyPor~(#1, #2){#1 \POR #2}
\def\Pthen{\@ifnextchar~{\applyPthen}{\_ \PTHEN \_}}
\def\applyPthen~(#1, #2){#1 \PTHEN #2}
\def\Pguard{\@ifnextchar~{\applyPguard}{\_ \PGUARD \_}}
\def\applyPguard~(#1, #2){#1 \PGUARD #2}
\def\Pexists{\@ifnextchar~{\applyPexists}{\PEXISTS\; \_\; :\; \_\; .\; \_}}
\def\applyPexists~(#1,#2,#3){\PEXISTS\; #1\; :\; #2\; .\; #3}
\def\Pforall{\@ifnextchar~{\applyPforall}{\PFORALL\; \_\; :\; \_\; .\; \_}}
\def\applyPforall~(#1,#2,#3){\PFORALL\; #1\; :\; #2\; .\; #3}   
\makeatother      
\def\Path{PATH}
\def\BPath{BPATH}
\def\OPath{OPATH}
\def\TPath{TPATH}
\def\SimpleType{SIMPLE\_TYPE}
\def\BClass{B\_CLASS}
\def\BAttribute{B\_ATTRIBUTE}

\def\TRUE{\texttt{TRUE}}
\def\FALSE{\texttt{FALSE}}
\def\NULL{\texttt{NULL}}
\def\SELECT{\texttt{SELECT}}
\def\SELECTINTO{\texttt{SELECT\_INTO}}
\def\UPDATE{\texttt{UPDATE}}
\def\INSERT{\texttt{INSERT}}
\def\INTO{\texttt{INTO}}
\def\VALUE{\texttt{VALUE}}
\def\DELETE{\texttt{DELETE}}
\def\FROM{\texttt{FROM}}
\def\DECLARE{\texttt{DECLARE}}
\def\CURSOR{\texttt{CURSOR}}
\def\FOR{\texttt{FOR}}
\def\DECLAREVAR{\texttt{DECLARE}_{var}}
\def\DECLARECUR{\texttt{DECLARE}_{cur}}
\def\SET{\texttt{SET}}
\def\WHERE{\texttt{WHERE}}
\def\IfThenElse{\texttt{IfThenElse}}
\def\SQLIf{\texttt{IF}}
\def\SQLThen{\texttt{THEN}}
\def\SQLElse{\texttt{ELSE}}
\def\WHILE{\texttt{WHILE}}
\def\DO{\texttt{DO}}
\def\END{\texttt{END}}
\def\OPEN{\texttt{OPEN}}
\def\CLOSE{\texttt{CLOSE}}
\def\FETCH{\texttt{FETCH}}
\def\RETURN{\texttt{RETURN}}

\def\UNION{\texttt{UNION}}
\def\INTERSECT{\texttt{INTERSECT}}
\def\EXCEPT{\texttt{EXCEPT}}
\def\COUNT{\texttt{COUNT}}
\def\SUM{\texttt{SUM}}
\def\MIN{\texttt{MIN}}
\def\NOT{\texttt{NOT}}
\def\AND{\texttt{AND}}
\def\OR{\texttt{OR}}
\def\NEG{\texttt{-}}
\def\PLUS{\texttt{+}}
\def\MINUS{\texttt{-}}
\def\TIMES{\texttt{*}}
\def\DIVIDE{\texttt{/}}
\def\EQ{\texttt{=}}
\def\NEQ{\texttt{<>}}
\def\GT{\texttt{>}}
\def\LT{\texttt{<}}
\def\GTEQ{\texttt{>=}}
\def\LTEQ{\texttt{<=}}
\def\IN{\texttt{IN}}
\def\NIN{\texttt{NOT IN}}

\def\OBJSystem{System_{obj}}

\def\State{{\cal{S}}}
\def\OBJState{\State_{obj}}
\def\TABState{\State_{tab}}
\def\SQLState{\State_{sql}}

\def\TabRelSql{\Table \rel \Sql}

\def\Relation{{\cal{R}}}
\def\OBJRelation{\Relation_{obj}}
\def\SQLRelation{\Relation_{sql}}
\newcommand{\decl}[1]{
  {\small \texttt{#1} }
}
\def\lsb{[}
\def\rsb{]}    
\def\seqins~(#1)~(#2)~(#3){\mathrm{ins}~(#1, #2, #3)}
\def\seqdel~(#1)~(#2){\mathrm{del}~(#1, #2)}
\def\seqtake~(#1)~(#2){#1_{\dots #2}}
\def\seqdrop~(#1)~(#2){#1_{#2+\mathrm{1} \dots}}    

\def\mappings{{\cal{M}}}

\def\primitiveMappings{\mappings_{prim}}
\def\assocMappings{\mappings_{assoc}}
\def\setMappings{\mappings_{set}}
\def\seqMappings{\mappings_{seq}}

\def\twoCellMappings{\mappings_{2cols}}
\def\threeCellMappings{\mappings_{3cols}} 

\newcommand{\nTab}[1]{\lbag~#1~\rbag^{NTab}}   
\newcommand{\nCol}[1]{\lbag~#1~\rbag^{NCol}} 
\newcommand{\oidToSV}[1]{\lbag~#1~\rbag^{SV}} % to scalar values in databases
\newcommand{\natToSV}[1]{\lbag~#1~\rbag^{SV}}
\newcommand{\valToSV}[1]{\lbag~#1~\rbag^{SV}}
\newcommand{\primToSV}[1]{\lbag~#1~\rbag^{SV}}

\def\OBJio{IO_{obj}}
\def\SQLio{IO_{sql}} 

\def\TARGET{target}
\def\CONTEXT{context}
\newcommand{\target}[1]{\TARGET~\lbag~#1~\rbag}
\newcommand{\context}[1]{\CONTEXT~\lbag~#1~\rbag}

\def\TabRelSql{\Table \rel \Sql}

\def\Relation{{\cal{R}}}
\def\OBJRelation{\Relation_{obj}}
\def\SQLRelation{\Relation_{sql}}          

\def\AssignObj{Assign_{obj}}
\def\AssignTab{Assign_{tab}}

\def\EffectObj{effect_{obj}}
\def\EffectTab{effect_{tab}}
\def\EffectSql{effect_{sql}}

\def\extentobj{extent_{obj}}
\def\valueobj{value_{obj}}
\def\extenttab{extent_{tab}}
\def\valuetab{value_{tab}}

\def\evalsql{eval_{sql}}
\def\evalsqlseq{eval^{*}_{sql}}

\def\cursorpos{cursor_{pos}}
\def\cursorvals{cursor_{vals}}  

\newcommand{\ObjToSQLState}[1]{\lbag~#1~\rbag^{sql}_{state}}
\newcommand{\ObjToSQLIO}[1]{\lbag~#1~\rbag^{sql}_{io}}
\newcommand{\GSLToRel}[1]{\lbag~#1~\rbag_{obj}}
\newcommand{\StmtToRel}[1]{\lbag~#1~\rbag_{sql}}
\newcommand{\StmtsToRel}[1]{\lbag~#1~\rbag_{\seq sql}}
\newcommand{\satisfyingOBJ}[1]{\lbag~#1~\rbag_{obj}^{states}}  
\newcommand{\satisfyingSQL}[1]{\lbag~#1~\rbag_{sql}^{states}}  

\newcommand{\SQLUpdate}[3]{\UPDATE \; #1 \; \SET \; #2 \; \WHERE \; #3}  
\newcommand{\SQLInsert}[3]{\INSERT~\INTO \; #1 \; (#2) \; \VALUE \; (#3)}
\newcommand{\SQLDelete}[2]{\DELETE~\FROM \; #1 \; \WHERE \; #2}


\def\emptysetexpr{\{\}}  
\def\splitsetexpr{\{y\} \cup A}             

\newcommand{\substituteInProg}[3]{#3~[~#2~/~#1~]}
\def\varpathx{x}       
\def\varexpry{y} % dummy variable path as expression         
\def\rangesetexpr{A}

                                                              
\newtheorem{lemma}{Lemma}[section] 
\newtheorem{theorem}{Theorem}[section]   
\newtheorem{proof}{Proof}[section]   
\newtheorem{definition}{Definition}[section] 
\newtheorem{example}{Example}  

\newcommand{\SQLIfThenElse}[3]{\SQLIf \; #1 \; \SQLThen \; #2 \; \SQLElse \; #3} 

\newcommand{\SQLWhile}[2]{\WHILE \; #1 \; \DO \; #2 \; \END \; \WHILE}


\usepackage{tabularx}
\usepackage{rotating}    
\usepackage{slashbox}
\usepackage[T1]{fontenc} % for \textsc   

\usepackage{relsize}  % for adjusting font size in fancyvrb

\usepackage{fancyhdr} % fancy header
\pagestyle{fancy}

\usepackage{fancyvrb, courier} % for fancyvrb
\renewcommand\ttdefault{txtt}     
  
\renewcommand{\labelitemi}{--}      
\newcommand{\word}[1]{{\small \texttt{#1}}}  
\DefineVerbatimEnvironment{code}{Verbatim}{frame=none, framesep=10mm, fontsize=\footnotesize}    
\DefineVerbatimEnvironment{booster}{Verbatim}{frame=none, framesep=10mm, fontsize=\footnotesize, commandchars=~\[\]}

\def\smallvskip{\smallskip \\}

\def\bigbrace{\left(
        \begin{array}{c}
        \begin{block}}
\def\endbigbrace{\end{block}
        \end{array} 
    \right)}
          
\def\bigbrace{\left(
        \begin{array}{c}
        \begin{block}}
\def\endbigbrace{\end{block}
        \end{array} 
    \right)}

\def\bigcbrace{\left\{
		\begin{array}{c}
	    \begin{block}}
\def\endbigcbrace{\end{block}
	    \end{array} 
	\right\}}